#ifndef SANGURU_SEGMENT_BASIC_H_ 
#define SANGURU_SEGMENT_BASIC_H_ 
#include "Arduino.h"

class SanguruSegmentBasic {
  public:

  // constructor 에는 void 조차도 없다.
  SanguruSegmentBasic(byte inLatchPin, byte inClkPin, byte inDataPin);
  void writePattern(byte digit, byte pattern);
  void write(int number);
  void write(float number, byte decimalPlaces);
  // ISR에 이 메쏘드를 넣어야 한다.
  void update();

  // common digit 배선이 역순으로 되어 있을 때 사용
  void setDigitOrderHigh();

  // common cathode 일 때 사용 
  void setCommonCathode();

  // 밝기를 1~7단계로 표시. 높을 수록 밝다. 기초값 5
  void setBrightness(byte bright);

  //const bytenum[] = {63, 6, 91, 79, 102, 109, 125, 7, 127, 111};
  const byte num[10] = {
  	B00111111,  // 0
  	B00000110,  // 1
  	B01011011,  // 2
  	B01001111,  // 3
  	B01100110,  // 4
  	B01101101,  // 5
  	B01111101,  // 6
  	B00000111,  // 7
  	B01111111,  // 8
  	B01101111   // 9
  };
  const byte A = B00000001;
  const byte B = B00000010;
  const byte C = B00000100;
  const byte D = B00001000;
  const byte E = B00010000;
  const byte F = B00100000;
  const byte G = B01000000;
  const byte DP= B10000000;
  const byte Blank = B00000000;

  volatile byte buffer[4];

  private:
  byte latchPin,clkPin,dataPin;
  byte digitOrderLowOrHigh = LOW;
  byte bright = 5;
  bool commonAnode = true;    

  const byte digit[4] = {0x01,0x02,0x04,0x08};
  // ISR에서 수정되거나 사용되는 변수는 volatile을 지정해야 값이 안전하게 전달된다.
  
  volatile byte digitLoop = 0;
  volatile int eachDigitLoop[4];
};
//↑ class 뒤에는 ;가 있어야 한다.
#endif